//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int SignalPin= 6; // EAX signal pin
extern ENUM_TIMEFRAMES RunTF = 15; // Signaling timeframe;
extern bool SignalClose= true; // Bar close changes signal
extern bool SignalChange= true; // Only signal once cross bar 


extern string strGridcheck="=============MIN GRID==============";
extern int GridPips=15; //Minimum Pips dist between trades


extern string Req_indi="ASCTrend1i-Alert";

extern int    Risk=6;            /* Risk */  // Risk level. WPR_Period=3+Risk*2 or WPR_Period=ALT_PERIOD for a large move 
extern int    BarCount=0;        /* Bar Count */  // 0 for full chart buffer
extern int    Alert_OnBar=1;     /* Alert - On change of this Bar */ // Alert when this bar changes. = for curent bar, 1 for last closed bar
extern bool   Alert_Popup=False; /* Alert - Popup Msg */ // Enable popup window & sound on alert
extern string Alert_SoundUp="";  /* Alert - Play Sound File for Buy Signal */ // Play sound on alert. Wav files only
extern string Alert_SoundDn="";  /* Alert - Play Sound File for Sell Signal */ // Play sound on alert. Wav files only
extern bool   Alert_Email=False; /* Alert - Send eMail */ // Enable send email on alert
extern string Alert_Subject=""; 


extern int SignalDelay=1;
extern int ReadDelay=2;



/*
extern string rsistring="========================RSI FILTER=====================";
extern bool USERSI=true;
extern int RSI_period=2;
extern int RSITF=0;
extern int RSI_OverBought=70; // Enter Upper Limit of RSI
extern int RSI_OverSold=30; //Enter Lower Limit of RSI
*/

string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs
string suffix = StringSubstr(Symbol(),6,0);
int offset = ((SignalClose) ? 1 : 0);
int signal,i;
double ma,open,close;
double  multiplier;
bool ExceedMinDist;


double Asctrend_Sig, Asctrend_Sigprev,RSI_sig;

#define NONE 0
#define CROSSUP 1
#define CROSSDOWN 2
#define ABOVE 1
#define BELOW 2
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   
   
   EventSetMillisecondTimer(ReadDelay*1000); //100 before
   if (BarCount<1 || BarCount>Bars) 
    BarCount=Bars-12;

 // gbInit=True;
  return(0);
  
   return(INIT_SUCCEEDED);
  }
  
  
  
  //+------------------------------------------------------------------+
//| Unit                        |
//+------------------------------------------------------------------+  
  int deinit()
  {
   
   for (i=0;i<28;i++){
   GlobalVariableSet(symbols[i]+"pin"+SignalPin,NONE);
   }
   return (0);
   
   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnTimer() {
   
   for (i=0;i<28;i++) {
      //RSI_sig=iRSI(Symbol(),RSITF,RSI_period,PRICE_CLOSE,SignalDelay+0);
      
    //  ma = iMA(symbols[i]+suffix,RunTF,MAperiod,0,MAmethod,MAappliedprice,1);
     // open = iClose(symbols[i]+suffix,RunTF,offset);
     // close = iClose(symbols[i]+suffix,RunTF,offset);
     
     
      
      Asctrend_Sig=iCustom(symbols[i]+suffix,RunTF,"ASCTrend1i-Alert",Risk,BarCount,Alert_OnBar,Alert_Popup,Alert_SoundUp,Alert_SoundDn,Alert_Email,Alert_Subject,2,SignalDelay+0); //gives -1 for sell (1 for buy) on current
      Asctrend_Sigprev=iCustom(symbols[i]+suffix,RunTF,"ASCTrend1i-Alert",Risk,BarCount,Alert_OnBar,Alert_Popup,Alert_SoundUp,Alert_SoundDn,Alert_Email,Alert_Subject,2,SignalDelay+1); //gives 1 for sell (-1 for sell) on prev
      //Sleep (100);
      
     
     
     //===============================================================================
      double MinDist2move;
      MinDist2move= GridPips*Point*multiplier;
      // MinDist2move > MathAbs(LastOrderPrice-close)
   //---------------------
       if((   MathAbs(LastOrderPrice()-close)>=MinDist2move && ExistPositions()) || !ExistPositions()){
         
            ExceedMinDist =true;
      
      }else {
      
            ExceedMinDist =false;
      }
   //---------------------
   

      if (SignalChange) {
         signal = NONE;
         if (Asctrend_Sig ==1 && Asctrend_Sigprev==-1) {
            // if (USERSI and RSI_sig<RSI_OverBought) return;
             signal = CROSSUP;
         } else
            if (Asctrend_Sig ==-1 && Asctrend_Sigprev==1) {
              // if (USERSI && RSI_sig>RSI_OverSold) return;
               signal = CROSSDOWN;+9.......................................0
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               
               5
               52+
               552252222+5+52255
               5+
               9555225+
               9509+
               0.
               00
         }//ELSE ONCHANGE      
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
      } else {
        if (Asctrend_Sig ==-1 ) 
           // if (USERSI && RSI_sig>RSI_OverBought) return;
            GlobalVariableSet(symbols[i]+"pin"+SignalPin,BELOW);
         else
            if (Asctrend_Sig ==1 ) 
               //if (USERSI && RSI_sig>RSI_OverSold) return;
               GlobalVariableSet(symbols[i]+"pin"+SignalPin,ABOVE);
      }//NOT SIGNAL CHANGE
   }//FOR LOOP
}//ON TIMER




         //==================================================
                  double LastOrderPrice(){
                  for(int i=OrdersTotal();i>=0;i--){
                     OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
                        if(/*OrderMagicNumber()==MagicNos && */ OrderSymbol()==symbols[i]+suffix){
                        return(OrderOpenPrice());
                        }
                      }
                   return(0);
                    }
           
           //=======================================
           
           bool ExistPositions() 
           {
              for(int i=0; i<OrdersTotal(); i++) 
              {
                 if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
                 {
                    if (OrderSymbol()==symbols[i]+suffix ) 
                    {
                     return(True);
                    }
                 }
              }
            return(false);
           }
           
           //====================================