//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

//There was an error in the hgi lib that returns trendwave(blue) and rangewave (yellow) up as down
// and down as up so i reversed it in the switch statement by interchanging the  RANGEABOVE&&RANGEBELOW, TRENDABOVE && TRENDBELOW
// in the switch statements update in case of future changes in the lib


#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int SignalPin= 6; // EAX signal pin
extern ENUM_TIMEFRAMES RunTF = 15; // Signaling timeframe;
extern int SignalDelay=1;
extern int ReadDelay=2;
extern bool TradeTrend=true;
extern bool TradeRad=true;
extern bool TradeRange=false;
extern bool TradeRangeWave=false;
extern bool TradeTrendWave=false;
extern string str1="====Other Settings====";
extern int GridPips=10; //Minimum Pips dist between trades
extern bool SignalClose= true; // Bar close changes signal
//extern bool SignalChange= true; // Only signal once cross bar 

extern string Req_indi="HGI_v16.09";

extern int    BarCount=100;        /* Bar Count */  // 0 for full chart buffer
//extern int    Risk=6;            /* Risk */  // Risk level. WPR_Period=3+Risk*2 or WPR_Period=ALT_PERIOD for a large move 

//extern int    Alert_OnBar=1;     /* Alert - On change of this Bar */ // Alert when this bar changes. = for curent bar, 1 for last closed bar
//extern bool   Alert_Popup=False; /* Alert - Popup Msg */ // Enable popup window & sound on alert
//extern string Alert_SoundUp="";  /* Alert - Play Sound File for Buy Signal */ // Play sound on alert. Wav files only
//extern string Alert_SoundDn="";  /* Alert - Play Sound File for Sell Signal */ // Play sound on alert. Wav files only
//extern bool   Alert_Email=False; /* Alert - Send eMail */ // Enable send email on alert
//extern string Alert_Subject=""; 

#import "hgi_lib.ex4"
   enum SIGNAL {S_NONE=0,TRENDUP=1,TRENDDN=2,RANGEUP=3,RANGEDN=4,RADUP=5,RADDN=6};
   enum SLOPE {UNDEFINED=0,RANGEABOVE=1,RANGEBELOW=2,TRENDABOVE=3,TRENDBELOW=4};
   SIGNAL getHGISignal(string symbol,int timeframe,int shift);
   SLOPE getHGISlope (string symbol,int timeframe,int shift);
#import


bool isiCustom=true;



/*
extern string rsistring="========================RSI FILTER=====================";
extern bool USERSI=true;
extern int RSI_period=2;
extern int RSITF=0;
extern int RSI_OverBought=70; // Enter Upper Limit of RSI
extern int RSI_OverSold=30; //Enter Lower Limit of RSI
*/

string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY"};// 28 pairs
//string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs

string suffix = StringSubstr(Symbol(),6,0);
int offset = ((SignalClose) ? 1 : 0);
int signal,i;
double ma,open,close,multiplier;
bool ExceedMinDist;

int trendbuy,trendsell, rangebuy, rangesell,radbuy, radsell, yellowwave_buy,bluewave_buy,yellowwave_sell,bluewave_sell;
int hsignal,slope ;

#define NONE 0
#define CROSSUP 1
#define CROSSDOWN 2
#define ABOVE 1
#define BELOW 2
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  
  
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
  
   EventSetMillisecondTimer(ReadDelay*1000); //100 before
   if (BarCount<1 || BarCount>Bars) 
    BarCount=Bars-12;

  //gbInit=True;
  return(0);
  
   return(INIT_SUCCEEDED);
  }
  
  
  
  //+------------------------------------------------------------------+
//| Unit                        |
//+------------------------------------------------------------------+  
  int deinit()
  {
   
   for (i=0;i<28;i++){
   GlobalVariableSet(symbols[i]+"pin"+SignalPin,NONE);
   }
   return (0);
   
   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnTimer() {
   
   for (i=0;i<28;i++) {
      //RSI_sig=iRSI(Symbol(),RSITF,RSI_period,PRICE_CLOSE,SignalDelay+0);
      
    //  ma = iMA(symbols[i]+suffix,RunTF,MAperiod,0,MAmethod,MAappliedprice,1);
     // open = iClose(symbols[i]+suffix,RunTF,offset);
     // close = iClose(symbols[i]+suffix,RunTF,offset);.;`w
      
      hsignal = 0;
      slope  = 0;
      

         hsignal = getHGISignal(symbols[i]+suffix, RunTF, SignalDelay);//This library function looks for arrows.
         slope  = getHGISlope (symbols[i]+suffix, RunTF, SignalDelay);//This library function looks for wavy lines.
                  

      switch(hsignal)
   {
      case TRENDUP : trendbuy=1; break;
      case TRENDDN : trendsell=-1; break;
      case RANGEUP : rangebuy=1; break;
      case RANGEDN : rangesell=-1; break;
      case RADUP : radbuy=1; break;
      case RADDN : radsell=-1; break;
      default : trendbuy=0;trendsell=0;rangesell=0;rangebuy=0;radbuy=0;radsell=0;
   }
   
   switch(slope){
      case TRENDABOVE: bluewave_sell=-1; break;
      case TRENDBELOW: bluewave_buy=1; break;
      case RANGEABOVE : yellowwave_sell=-1;break;
      case RANGEBELOW : yellowwave_buy=1;break;
       default : bluewave_buy=0;bluewave_sell=0;yellowwave_buy=0;yellowwave_sell=0;
       
       }
       
   //===============================================================================
      double MinDist2move;
      MinDist2move= GridPips*Point*multiplier;
      // MinDist2move > MathAbs(LastOrderPrice-close)
   //---------------------
       if((   MathAbs(LastOrderPrice()-close)>=MinDist2move && ExistPositions()) || !ExistPositions()){
         
            ExceedMinDist =true;
      
      }else {
      
            ExceedMinDist =false;
      }
   //------------------------------------------------------------------------------
   
   

      bool checksignal=true;
      signal = NONE;
      
   if (checksignal){
         if (TradeTrend==true ) {
            
            if ( trendbuy==1 ) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (trendsell ==-1  )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
           
               } 
         
          GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
         
          if (TradeRange) {
            
            if ( rangebuy==1) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (rangesell ==-1 )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
            } 
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
          
          if (TradeRad) {
            
            //Alert (symbols[i]+suffix+radsell);
            if ( radbuy ==1 ) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (radsell ==-1 )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
         } 
         
          GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
         
          if (TradeRangeWave) {
            
            if (  yellowwave_buy==1 ) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (yellowwave_sell==-1 )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
         } 
      
          GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
          
          if (TradeTrendWave) {
            
            if (  bluewave_buy==1 ) 
               // if (USERSI and RSI_sig<RSI_OverBought) return;
                signal = CROSSUP;
            else
               if (bluewave_sell==-1 )
                 // if (USERSI && RSI_sig>RSI_OverSold) return;
                  signal = CROSSDOWN;
         } 
      
          GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
      
      }//check signal 
      
  
      
      
   }//for loop
}//on timer



//==================================================
         double LastOrderPrice(){
         for(int i=OrdersTotal();i>=0;i--){
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
               if(/*OrderMagicNumber()==MagicNos && */ OrderSymbol()==symbols[i]+suffix){
               return(OrderOpenPrice());
               }
             }
          return(0);
           }
  
  //=======================================
  
  bool ExistPositions() 
  {
     for(int i=0; i<OrdersTotal(); i++) 
     {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
        {
           if (OrderSymbol()==symbols[i]+suffix ) 
           {
            return(True);
           }
        }
     }
   return(false);
  }
  
  //====================================