//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int SignalPin= 6; // EAX signal pin
extern ENUM_TIMEFRAMES RunTF = 15; // Signaling timeframe;
extern double EntryThreshold=0.5;
extern double ExitThreshold=0.2;
extern int SignalDelay=0;
extern int ReadDelay=2;// Read indicator delay in seconds

extern bool SignalClose= true; // Bar close changes signal
//extern bool SignalChange= false; // ON change of signal


extern string Req_indi="Mega_Fx";

//=======Mega trend Inputs====
extern bool ALERTS = FALSE;
extern bool SoundAlerts = FALSE;
extern string SoundAlertFile = "alert.wave";
extern bool eMailAlerts = FALSE;



/*
extern string rsistring="========================RSI FILTER=====================";
extern bool USERSI=true;
extern int RSI_period=2;
extern int RSITF=0;
extern int RSI_OverBought=70; // Enter Upper Limit of RSI
extern int RSI_OverSold=30; //Enter Lower Limit of RSI
*/

//string symbols[] = {"AUDCAD","AUDJPY","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCAD","CADJPY","NZDUSD","NZDJPY"};// Enter Trading Pairs
string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs
//string symbols[] = {"AUDCAD","AUDJPY","AUDUSD"};// Enter Trading Pairs
string suffix = StringSubstr(Symbol(),6,0);
int offset = ((SignalClose) ? 1 : 0);
int signal,i;
double ma,open,close;
string objPrefix;
string captionText;

double MegaFx_BuySig, MegaFx_BuySigprev,RSI_sig;
double MegaFx_SellSig, MegaFx_SellSigprev;

double MegaFx_BuySig_Continous;
double MegaFx_SellSig_Continous;


bool BuyOnly, SellOnly, BuyTrig, SellTrig;


#define NONE 0
#define CROSSUP 1
#define CROSSDOWN 2
#define ABOVE 1
#define BELOW 2
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  
 
  
   EventSetMillisecondTimer(ReadDelay*1000); //100 before
   return(INIT_SUCCEEDED); 
  }
  
//+------------------------------------------------------------------+
//| Unit                        |
//+------------------------------------------------------------------+  
  int deinit()
  {
   
   for (i=0;i<28;i++){
   GlobalVariableSet(symbols[i]+"pin"+SignalPin,NONE);
   }
   return (0);
   
   
  }
//+---
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnTimer() {
   
   for (i=0;i<28;i++) {
      //RSI_sig=iRSI(Symbol(),RSITF,RSI_period,PRICE_CLOSE,SignalDelay+0);
      
      /*
      //One of Signals/
      MegaFx_BuySig=iCustom(symbols[i]+suffix,RunTF,"Mega_Fx",ALERTS,SoundAlerts,SoundAlertFile,eMailAlerts,4,SignalDelay+0); //value not empty on signal
      MegaFx_BuySigprev=iCustom(symbols[i]+suffix,RunTF,"Mega_Fx",ALERTS,SoundAlerts,SoundAlertFile,eMailAlerts,4,SignalDelay+1);  //value not empty on signal
   
      MegaFx_SellSig=iCustom(symbols[i]+suffix,RunTF,"Mega_Fx",ALERTS,SoundAlerts,SoundAlertFile,eMailAlerts,5,SignalDelay+0);  //value not empty on signal
      MegaFx_SellSigprev=iCustom(symbols[i]+suffix,RunTF,"Mega_Fx",ALERTS,SoundAlerts,SoundAlertFile,eMailAlerts,5,SignalDelay+1);  //value not empty on signal
   */
     
      //Continous Signals
         MegaFx_BuySig_Continous=iCustom(symbols[i]+suffix,RunTF,"Mega_Fx",ALERTS,SoundAlerts,SoundAlertFile,eMailAlerts,1,SignalDelay+0);  //value not empty on signal
         MegaFx_SellSig_Continous=iCustom(symbols[i]+suffix,RunTF,"Mega_Fx",ALERTS,SoundAlerts,SoundAlertFile,eMailAlerts,2,SignalDelay+0);  //value not empty on signal
     
      
      if (MegaFx_BuySig_Continous > ExitThreshold){
         BuyOnly=true;
      }else {
         BuyOnly=false;
         BuyTrig=false;
      }
      if (MegaFx_SellSig_Continous <-ExitThreshold){
         SellOnly=true;
      }else {
         SellOnly=false;
         SellTrig=false;
      }
      
      if (MegaFx_BuySig_Continous > EntryThreshold){
         BuyTrig=true;
      }
      if (MegaFx_SellSig_Continous < -EntryThreshold){
         SellTrig=true;
      }
      
      
     // if (symbols[i]+suffix == "USDCHF"){ Alert ( BuyOnly + " " + BuyTrig + " " +SellOnly + " " + SellTrig );}
     // open = iClose(symbols[i]+suffix,RunTF,offset);
     // close = iClose(symbols[i]+suffix,RunTF,offset);

        if (BuyTrig &&  BuyOnly ) 
           // if (USERSI && RSI_sig>RSI_OverBought) return;
            GlobalVariableSet(symbols[i]+"pin"+SignalPin,ABOVE);
         else
            if (SellTrig && SellOnly ) 
               //if (USERSI && RSI_sig>RSI_OverSold) return;
               GlobalVariableSet(symbols[i]+"pin"+SignalPin,BELOW);
      }//esle
  // }//signal change
}