//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int SignalPin= 6; // EAX signal pin
extern ENUM_TIMEFRAMES RunTF = 15; // Signaling timeframe;
extern bool SignalClose= true; // Bar close changes signal
extern bool SignalCross= false; // Only signal once cross bar 
extern int MAperiod= 34; // Period for calculation of moving average
extern int MAmethod= 0; // 0=Simple ma/ 1=Exponential ma/ 2=Smoothed ma/ 3=Linear weighted ma
extern int MAappliedprice= 0; // 0=Close/ 1=Open/ 2=High/ 3=Low/ 4=Median/ 5=Typical/ 6=Weighted

string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs
string suffix = StringSubstr(Symbol(),6,0);
int offset = ((SignalClose) ? 1 : 0);
int signal,i;
double ma,open,close;

#define NONE 0
#define CROSSUP 1
#define CROSSDOWN 2
#define ABOVE 1
#define BELOW 2
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   EventSetMillisecondTimer(100);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnTimer() {
   
   for (i=0;i<28;i++) {
      ma = iMA(symbols[i]+suffix,RunTF,MAperiod,0,MAmethod,MAappliedprice,1);
      open = iClose(symbols[i]+suffix,RunTF,offset);
      close = iClose(symbols[i]+suffix,RunTF,offset);

      if (SignalCross) {
         signal = NONE;
         if (open < ma && close > ma) 
            signal = CROSSUP;
         else
            if (open > ma && close < ma)
               signal = CROSSDOWN;
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
      } else {
         if (close < ma) 
            GlobalVariableSet(symbols[i]+"pin"+SignalPin,BELOW);
         else
            if (close > ma)
               GlobalVariableSet(symbols[i]+"pin"+SignalPin,ABOVE);
      }
   }
}