//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int SignalPin= 3; // EAX signal pin
extern ENUM_TIMEFRAMES RunTF = 15; // Signaling timeframe;
extern int SignalDelay=1;
extern int ReadDelay=2;

extern string strATRcheck="==================PRICE DIST CHECK================";
extern bool UseClose2MA_Filter=true;
extern int ATRdistMUL =10;  //Enter multiplier of distance from ma
extern bool  useManualPip =false;
extern int manualATRdist=15;    //Enter minimum MA distance to consider counter signal
extern int atr_period=21;
extern bool SignalClose= true; // Bar close changes signal
extern string stng="===========================================================";
extern string Req_indi="240.V.7_CT_ BUY.SELL.NOW.ALERT";

extern int    BarCount=100;        /* Bar Count */  // 0 for full chart buffer


double ma1,atr1,MinPriceDist;
int currentdist;
bool isWithinTradeZone;
double pipPoint;


/*
extern string rsistring="========================RSI FILTER=====================";
extern bool USERSI=true;
extern int RSI_period=2;
extern int RSITF=0;
extern int RSI_OverBought=70; // Enter Upper Limit of RSI
extern int RSI_OverSold=30; //Enter Lower Limit of RSI
*/

string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs
string suffix = StringSubstr(Symbol(),6,0);
int offset = ((SignalClose) ? 1 : 0);
int signal,i;
double ma,open,close;



#define NONE 0
#define CROSSUP 1
#define CROSSDOWN 2
#define ABOVE 1
#define BELOW 2
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   EventSetMillisecondTimer(ReadDelay*1000); //100 before
   if (BarCount<1 || BarCount>Bars) 
    BarCount=Bars-12;

  //gbInit=True;
  return(0);
  
   return(INIT_SUCCEEDED);
  }
  
  
  
  //+------------------------------------------------------------------+
//| Unit                        |
//+------------------------------------------------------------------+  
  int deinit()
  {
   
   for (i=0;i<28;i++){
   GlobalVariableSet(symbols[i]+"pin"+SignalPin,NONE);
   }
   return (0);
   
   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnTimer() {
   
   for (i=0;i<28;i++) {
      //RSI_sig=iRSI(Symbol(),RSITF,RSI_period,PRICE_CLOSE,SignalDelay+0);
      
    //  ma = iMA(symbols[i]+suffix,RunTF,MAperiod,0,MAmethod,MAappliedprice,1);
     // open = iClose(symbols[i]+suffix,RunTF,offset);
     // close = iClose(symbols[i]+suffix,RunTF,offset);
      
     // Asctrend_Sig=iCustom(symbols[i]+suffix,RunTF,"ASCTrend1i-Alert",Risk,BarCount,Alert_OnBar,Alert_Popup,Alert_SoundUp,Alert_SoundDn,Alert_Email,Alert_Subject,2,SignalDelay+0); //gives -1 for sell (1 for buy) on current
      //Asctrend_Sigprev=iCustom(symbols[i]+suffix,RunTF,"ASCTrend1i-Alert",Risk,BarCount,Alert_OnBar,Alert_Popup,Alert_SoundUp,Alert_SoundDn,Alert_Email,Alert_Subject,2,SignalDelay+1); //gives 1 for sell (-1 for sell) on prev
      //Sleep (100);
      
     double SBBbuy_c=iCustom(symbols[i]+suffix,RunTF,"240.V.7_CT_ BUY.SELL.NOW.ALERT", 0,SignalDelay+0);
      double SBBsell_c=iCustom(symbols[i]+suffix,RunTF,"240.V.7_CT_ BUY.SELL.NOW.ALERT", 1,SignalDelay+0);
    
      if (UseClose2MA_Filter){
         isWithinTradeZone=false;
         currentdist=0;
         
         
           string Sym = StringSubstr(symbols[i]+suffix,3,3);
         string Symbegin = StringSubstr(symbols[i]+suffix,3,3);
         
            if ((Sym=="JPY" || Symbegin=="XAU") && (Digits == 3  || Digits==5)){
                pipPoint=0.001;
            }else if((Sym=="JPY" || Symbegin=="XAU") && Digits == 2 ||Digits == 4) {
                pipPoint=0.01;
            }else {
                   pipPoint=Point;
            }
            
         
         
         atr1= iATR (symbols[i]+suffix,RunTF,atr_period,SignalDelay+0);
         ma1=iMA(symbols[i]+suffix,RunTF,120,0,MODE_LWMA,PRICE_CLOSE,SignalDelay+0);
         close = iClose(symbols[i]+suffix,RunTF,SignalDelay+0);
    
         if (useManualPip)
         {
            MinPriceDist=ATRdistMUL*manualATRdist;
         } 
         else
         {
            MinPriceDist= ATRdistMUL*(atr1/pipPoint);
         }
         
       
         double currentdist = (MathAbs(close-ma1))/pipPoint;
         
         if (currentdist>=MinPriceDist) isWithinTradeZone=true;
         
      }//useclosema filter
      
      
 
      signal = NONE;
      
      if (UseClose2MA_Filter==false){
         signal = NONE;
         if ( SBBbuy_c != EMPTY_VALUE ) {
            // if (USERSI and RSI_sig<RSI_OverBought) return;
             signal = CROSSUP;
         }
            if (SBBsell_c != EMPTY_VALUE ){
              // if (USERSI && RSI_sig>RSI_OverSold) return;
               signal = CROSSDOWN;
         }
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
         
      }// dont use close to ma filter
      else if (UseClose2MA_Filter){
          signal = NONE;
         if ( SBBbuy_c != EMPTY_VALUE && isWithinTradeZone ) {
            // if (USERSI and RSI_sig<RSI_OverBought) return;
             signal = CROSSUP;
         }
            if (SBBsell_c != EMPTY_VALUE && isWithinTradeZone ){
              // if (USERSI && RSI_sig>RSI_OverSold) return;
               signal = CROSSDOWN;
         }
         
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
      
      }// else use filter
      
   }//for loop
   
}//on timer