//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern int SignalPin= 3; // EAX signal pin
extern ENUM_TIMEFRAMES RunTF = 15; // Signaling timeframe;
extern int SignalDelay=1;
extern int ReadDelay=2;
extern string strGridcheck="=============MIN GRID==============";
extern int GridPips=15; //Minimum Pips dist between trades

extern string strATRcheck="============PRICE DIST CHECK===========";
extern bool UseClose2MA_Filter=true;
extern int ATRdistMUL =7;
extern bool  useManualPip =false;
extern int manualATRdist=15;  
extern int atr_period=21;
extern bool SignalClose= true; // Bar close changes signal
extern string stng="================================================";
extern string Req_indi="240.V.7_ BUY.SELL.NOW.ALERT";

extern int    BarCount=100;        /* Bar Count */  // 0 for full chart buffer


double ma1,atr1,MinPriceDist;
int currentdist;
bool isWithinTradeZone,ExceedMinDist;
double pipPoint;
double  multiplier;
double ma,open,close;

/*
extern string rsistring="========================RSI FILTER=====================";
extern bool USERSI=true;
extern int RSI_period=2;
extern int RSITF=0;
extern int RSI_OverBought=70; // Enter Upper Limit of RSI
extern int RSI_OverSold=30; //Enter Lower Limit of RSI
*/

string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs
string suffix = StringSubstr(Symbol(),6,0);
int offset = ((SignalClose) ? 1 : 0);
int signal,i;




#define NONE 0
#define CROSSUP 1
#define CROSSDOWN 2
#define ABOVE 1
#define BELOW 2
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  
  
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   
   
   EventSetMillisecondTimer(ReadDelay*1000); //100 before
   if (BarCount<1 || BarCount>Bars) 
    BarCount=Bars-12;

  //gbInit=True;
  return(0);
  
   return(INIT_SUCCEEDED);
  }
  
  
  
  //+------------------------------------------------------------------+
//| Unit                        |
//+------------------------------------------------------------------+  
  int deinit()
  {
   
   for (i=0;i<28;i++){
   GlobalVariableSet(symbols[i]+"pin"+SignalPin,NONE);
   }
   return (0);
   
   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnTimer() {
   
   for (i=0;i<28;i++) {
  
  
      
     ExceedMinDist =false;
      
      
     double SBBbuy=iCustom(symbols[i]+suffix,RunTF,"240.V.7_ BUY.SELL.NOW.ALERT", 0,SignalDelay+0);
     double SBBsell=iCustom(symbols[i]+suffix,RunTF,"240.V.7_ BUY.SELL.NOW.ALERT", 1,SignalDelay+0);
      
      
      
       string Sym = StringSubstr(symbols[i]+suffix,3,3);
         string Symbegin = StringSubstr(symbols[i]+suffix,0,3);
         
            if ((Sym=="JPY" || Symbegin=="XAU") && (Digits == 3  || Digits==5)){
                pipPoint=0.001;
            }else if((Sym=="JPY" || Symbegin=="XAU") && Digits == 2 ||Digits == 4) {
                pipPoint=0.01;
            }else {
                   pipPoint=Point;
            }
            
    //=================================================================================
    
      if (UseClose2MA_Filter){
         isWithinTradeZone=false;
         currentdist=0;
         
         
          
            
         
         
         atr1= iATR (symbols[i]+suffix,RunTF,atr_period,SignalDelay+0);
         ma1=iMA(symbols[i]+suffix,RunTF,120,0,MODE_LWMA,PRICE_CLOSE,SignalDelay+0);
         close = iClose(symbols[i]+suffix,RunTF,SignalDelay+0);
    
         if (useManualPip)
         {
            MinPriceDist=ATRdistMUL*manualATRdist;
         } 
         else
         {
            MinPriceDist= ATRdistMUL*(atr1/pipPoint);
         }
         
       
         double currentdist = (MathAbs(close-ma1))/pipPoint;
         
         if (currentdist<=MinPriceDist) isWithinTradeZone=true;
         
      }//useclosema filter
      
   //===============================================================================
      double MinDist2move;
      MinDist2move= GridPips*pipPoint*multiplier;
       close = iClose(symbols[i]+suffix,RunTF,SignalDelay+0);
      // MinDist2move > MathAbs(LastOrderPrice-close)
   //---------------------
       if((   MathAbs(LastOrderPrice()-close)>=MinDist2move && ExistPositions()) || !ExistPositions()){
         
            ExceedMinDist =true;
      
      }else {
      
            ExceedMinDist =false;
      }
   //---------------------
   
   
   //COLLECT ISUFFIX 
   
   
   //============================================================================   
 
      signal = NONE;
      
      if (UseClose2MA_Filter==false){
         signal = NONE;
         if ( SBBbuy != EMPTY_VALUE && ExceedMinDist ==true ) {
            // if (USERSI and RSI_sig<RSI_OverBought) return;
             signal = CROSSUP;
         }
            if (SBBsell != EMPTY_VALUE && ExceedMinDist ==true ){
              // if (USERSI && RSI_sig>RSI_OverSold) return;
               signal = CROSSDOWN;
         }
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
         
      }// dont use close to ma filter
      else if (UseClose2MA_Filter){
          signal = NONE;
         if ( SBBbuy != EMPTY_VALUE && isWithinTradeZone && ExceedMinDist ==true ) {
            // if (USERSI and RSI_sig<RSI_OverBought) return;
             signal = CROSSUP;
         }
            if (SBBsell != EMPTY_VALUE && isWithinTradeZone && ExceedMinDist ==true ){
              // if (USERSI && RSI_sig>RSI_OverSold) return;
               signal = CROSSDOWN;
         }
         
         GlobalVariableSet(symbols[i]+"pin"+SignalPin,signal);
      
      }// else use filter
      
   }//for loop
   
}//on timer



//==================================================
         double LastOrderPrice(){
         for(int i=OrdersTotal();i>=0;i--){
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
               if(/*OrderMagicNumber()==MagicNos && */ OrderSymbol()==symbols[i]+suffix){
               return(OrderOpenPrice());
               }
             }
          return(0);
           }
  
  //=======================================
  
  bool ExistPositions() 
  {
     for(int i=0; i<OrdersTotal(); i++) 
     {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
        {
           if (OrderSymbol()==symbols[i]+suffix ) 
           {
            return(True);
           }
        }
     }
   return(false);
  }
  
  //====================================