//+------------------------------------------------------------------+
//|                                                          PIN.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#include "PIN.mqh"
Pin * pins[28];
  string symbols[] = { "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","GBPJPY","GBPAUD","GBPCAD","GBPCHF","GBPNZD","GBPUSD","USDJPY","USDCAD","USDCHF","EURUSD","EURGBP","EURJPY","EURNZD","EURAUD","EURCHF","EURCAD","CADJPY","CADCHF","NZDCAD","NZDUSD","NZDJPY","NZDCHF","CHFJPY" };// 28 pairs
extern int SignalPin= 6; // EAX signal pin
extern int MAperiod= 34; // Period for calculation of moving average
extern int MAmethod= 0; // 0=Simple ma/ 1=Exponential ma/ 2=Smoothed ma/ 3=Linear weighted ma
extern int MAappliedprice= 0; // 0=Close/ 1=Open/ 2=High/ 3=Low/ 4=Median/ 5=Typical/ 6=Weighted
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   for( int i=0;i<28;i++ )
   pins[i] = new Pin( symbols[i], SignalPin );
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
for( int i=0; i<28; i++ )
	pins[i].set(FRAMEWORKPINCMD(pin(i))); 

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

int pin( int i ) {
  double price[2];

   price[0] = iMA( symbols[ i ], 0, MAperiod, 0, MAmethod, MAappliedprice, 1 );
   price[1] =  iClose(symbols[ i ], 0, 1);

	if ( price[ 1 ] > price[ 0 ] )
		return( 1 );
	if ( price[ 1 ] < price[ 0 ] )
		return( 2 );

return( 0 );
}